







































































extern	struct	_iobuf {
	int	_cnt;
	unsigned char *_ptr;
	unsigned char *_base;
	int	_bufsiz;
	short	_flag;
	char	_file;		
} _iob[];




































extern struct _iobuf	*fopen();
extern struct _iobuf	*fdopen();
extern struct _iobuf	*freopen();
extern struct _iobuf	*popen();
extern struct _iobuf	*tmpfile();
extern long	ftell();
extern char	*fgets();
extern char	*gets();
extern char	*sprintf();
extern char	*ctermid();
extern char	*cuserid();
extern char	*tempnam();
extern char	*tmpnam();


















extern	char	_ctype_[];










































typedef	int		sigset_t;	

typedef	unsigned int	speed_t;	
typedef	unsigned long	tcflag_t;	
typedef	unsigned char	cc_t;		
typedef	int		pid_t;		

typedef	unsigned short	mode_t;		
typedef	short		nlink_t;	

typedef	long		clock_t;	
typedef	long		time_t;		

typedef	int		size_t;		
typedef int		ptrdiff_t;	

typedef	unsigned short	wchar_t;	



























typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;
typedef	unsigned short	ushort;		
typedef	unsigned int	uint;		





typedef	struct  _physadr_t { int r[1]; } *physadr_t;
typedef	struct label_t {
	int	val[2];
} label_t;


typedef	struct	_quad_t { long val[2]; } quad_t;
typedef	long	daddr_t;
typedef	char *	caddr_t;
typedef	unsigned long	ino_t;
typedef	short	dev_t;
typedef	long	off_t;
typedef	unsigned short	uid_t;
typedef	unsigned short	gid_t;
typedef	long	key_t;
typedef	char *	addr_t;














typedef	long	fd_mask;







typedef	struct fd_set {
	fd_mask	fds_bits[(((256)+(( (sizeof (fd_mask) * 8))-1))/( (sizeof (fd_mask) * 8)))];
} fd_set;





























struct	stat {
	dev_t	st_dev;
	ino_t	st_ino;
	mode_t	st_mode;
	short	st_nlink;
	uid_t	st_uid;
	gid_t	st_gid;
	dev_t	st_rdev;
	off_t	st_size;
	time_t	st_atime;
	int	st_spare1;
	time_t	st_mtime;
	int	st_spare2;
	time_t	st_ctime;
	int	st_spare3;
	long	st_blksize;
	long	st_blocks;
	long	st_spare4[2];
};






















































int	chmod();
int	fstat();
int	mkdir();
int	mkfifo();
int	stat();
mode_t	umask();





















struct timeval {
	long	tv_sec;		
	long	tv_usec;	
};

struct timezone {
	int	tz_minuteswest;	
	int	tz_dsttime;	
};































struct	itimerval {
	struct	timeval it_interval;	
	struct	timeval it_value;	
};





















struct	tm {
	int	tm_sec;
	int	tm_min;
	int	tm_hour;
	int	tm_mday;
	int	tm_mon;
	int	tm_year;
	int	tm_wday;
	int	tm_yday;
	int	tm_isdst;
	char	*tm_zone;
	long	tm_gmtoff;
};

extern	struct tm *gmtime(), *localtime();
extern	char *asctime(), *ctime();
extern	void tzset(), tzsetwall();
extern  int dysize();
extern  time_t timelocal(), timegm();















char	*strcat();
char	*strncat();
int	strcmp();
int	strncmp();
int	strcasecmp();
char	*strcpy();
char	*strncpy();
int	strlen();
char	*index();
char	*rindex();







    



    



    



    



    












    









   



int is_binaryfile();
void print_standard_prologue();
void startpage(), endpage();




int numbering = 0;		
int folding = 1;		
int restart = 0;		
int only_printable = 0;	
int interpret = 1;		
int print_binaries = 0;	 
int landscape = 1;		
int new_landscape = 1;	
int wide_pages = 0;         
int new_wide_pages = 0;	
int twinpage = 1;		
int twinfiles = 0;		
int no_header = 0;		
int no_border = 0;		
int printdate = 0;		

int lpr_print = 1;	





int column = 0;			
int line = 0;			
int line_number = 0;		
int pages = 0;			
int sheets = 0;			
int old_pages, old_sheets;	
int sheetside = 0;		
int linesperpage;		
int lines_requested = 0;	
int new_linesrequest = 0;	
int columnsperline;		
int nonprinting_chars, chars;	
int copies_number = 1;		
int column_width = 8;	        




int first_page;			
int no_files = 1;		
int prefix_width;		
float fontsize = 0.0;		
float new_fontsize = 0.0;	
char *command;			
char *lpr_opt = 0;		
char *header_text = 0;	
char *prologue = 0;		




double page_height = 11.64;	
double page_width = 8.27;	




void
usage()
{
    fprintf((&_iob[2]),"Usage: %s [options] [ f1 [ [H_opt] f2 ...] ]\n", command);
    fprintf((&_iob[2]),"options = -#num\t\tnumber of copies to print\n");
    fprintf((&_iob[2]),"          -?\t\tprint this information\n");
    fprintf((&_iob[2]),"          -b\t-nb\tforce (DON'T FORCE) binary printing\n");
    fprintf((&_iob[2]),"          -c\t-nc\tallow (DON'T ALLOW) two files on the same sheet\n");
    fprintf((&_iob[2]),"          -d\t-nd\tPRINT (don't print) current date at the bottom\n");
    fprintf((&_iob[2]),"          -Fnum\t\tfont size, num is a float number\n");
    fprintf((&_iob[2]),"          -f\t-nf\tFOLD (don't fold) lines\n");
    fprintf((&_iob[2]),"          -Hstr\t\tuse str like header title for subsequent files\n");
    fprintf((&_iob[2]),"          \t-nH\tdon't print any header\n");
    fprintf((&_iob[2]),"          -h\t\tprint this information\n");
    fprintf((&_iob[2]),"          -Ifile\t\tinclude this file as a2ps prologue\n");
    fprintf((&_iob[2]),"          -i\t-ni\tINTERPRET (don't interpret) tab, bs and ff chars\n");
    fprintf((&_iob[2]),"          -lnum\t\tuse num lines per page\n");
    fprintf((&_iob[2]),"          -m\t\tprocess the file as a man\n");
    fprintf((&_iob[2]),"          -n\t-nn\tNUMBER (don't number) line files\n");

    fprintf((&_iob[2]),"          -Pprinter\t-nP\tSEND (don't send) directly to the printer");

    if ("-l" != 0 && sizeof("-l") > 0)
	fprintf((&_iob[2]),"\n             (with options '%s' and -Pprinter)", "-l");

    fprintf((&_iob[2]), "\n");

    fprintf((&_iob[2]),"          -p\t-np\tprint in portrait (LANDSCAPE) mode\n");
    fprintf((&_iob[2]),"          -r\t-nr\tRESTART (don't restart) page number after each file\n");
    fprintf((&_iob[2]),"          -s\t-ns\tPRINT (don't print) surrounding borders\n");
    fprintf((&_iob[2]),"          -tnum\t\tset tab size to n\n");
    fprintf((&_iob[2]),"          -v\t-nv\tVISIBLE (blank) display of unprintable chars\n");
    fprintf((&_iob[2]),"          -w\t-nw\twide (NARROW, 2-up if landscape)\n");
    exit(1);
}




void
set_global_option(arg)
char *arg;
{
    switch (arg[1]) {
    case '?':				
    case 'h':
	usage();
    case 'b':				
	if (arg[2] != 0)
	    usage();
	print_binaries = 1;
	break;
    case 'c':				
	if (arg[2] != 0)
	    usage();
	twinfiles = 1;
	break;
    case 'f':				
	if (arg[2] != 0)
	    usage();
	folding = 1;
	break;
    case 'I':				
	if (arg[2] == 0)
	    usage();
	    prologue = arg+2;
	break;
    case 'i':				
	if (arg[2] != 0)
	    usage();
	interpret = 1;
	break;
    case 'n':
	if (arg[2] == 0)
	    return;
	if (arg[3] != 0)
	    usage();
	switch (arg[2]) {
	case 'b':			
	    print_binaries = 0;
	    break;
	case 'c':			
	    twinfiles = 0;
	    break;
	case 'f':			
	    folding = 0;
	    break;
	case 'H':			
	    no_header = 1;
	    break;
	case 'i':			
	    interpret = 0;
	    break;

	case 'P':			
	    lpr_print = 0;
	    break;

	case 'r':			
	    restart = 0;
	    break;
	case 'v':			
	    only_printable = 1;
	    break;
	case 'd':
	case 'm':
	case 'n':
	case 'p':
	case 's':
	case 'w':
	    if (arg[3] != 0)
		usage();
	    return;
	default:
	    usage();
	}
	break;

    case 'P':				 
	if (arg[2] != 0) {
	    lpr_opt = (char *)malloc(strlen(arg)+1);
	    strcpy(lpr_opt, arg);
	}
	lpr_print = 1;
	break;

    case 'r':				
	if (arg[2] != 0)
	    usage();
	restart = 1;
	break;
    case 't':				
	if (arg[2] == 0 || (column_width = atoi(arg+2)) <= 0)
	    usage();
	break;
    case 'v':				
	if (arg[2] != 0)
	    usage();
	only_printable = 0;
	break;
    case 'd':
    case 'm':
    case 'p':
    case 's':
    case 'w':
	if (arg[2] != 0)
	    usage();
    case '#':
    case 'F':
    case 'H':
    case 'l':
	return;
    default:
	usage();
    }
    arg[0] = 0;
}







void
set_positional_option(arg)
char *arg;
{
    int copies;
    int lines;
    float size;

    switch (arg[1]) {
    case 0:				
	break;
    case '#':				
	if (sscanf(&arg[2], "%d", &copies) != 1 || copies <= 0)
	    fprintf((&_iob[2]), "Bad number of copies: '%s'. Ignored\n", &arg[2]);
	else
	    copies_number = copies;
	printf("/#copies %d def\n", copies_number);
	break;
    case 'd':				
	printdate = 1;
	break;
    case 'F':				
	if (arg[2] == 0 || sscanf(&arg[2], "%f", &size) != 1 || size == 0.0)
	{
	    fprintf((&_iob[2]), "Wrong value for option -F: '%s'. Ignored\n",
		    &arg[2]);
	    break;
	}
	new_fontsize = size;
	break;
    case 'H':				
	header_text = arg+2;
	break;
    case 'l':				
	
	
	if (arg[2] == 0 || sscanf(&arg[2], "%d", &lines) != 1 ||
	    lines < 0 || lines > 160)
	{
	    fprintf((&_iob[2]), "Wrong value for option -l: '%s'. Ignored\n",
		    &arg[2]);
	    break;
	}
	new_linesrequest = lines;
	break;
    case 'm':				
	new_linesrequest = 66;
	numbering = 0;
	break;
    case 'n':				
	if (arg[2] == 0) {
	    numbering = 1;
	    break;
	}
	switch (arg[2]) {
	case 'd':			
	    printdate = 0;
	    break;
	case 'm':			
	    new_linesrequest = 0;
	    break;
	case 'n':			
	    numbering = 0;
	    break;
	case 'p':			
	    new_landscape = 1;
	    break;
	case 's':			
	    no_border = 1;
	    break;
	case 'w':			
	    new_wide_pages = 0;
	    break;
	default:
	    usage();
	}
	break;
    case 'p':				
	if (arg[2] != 0)
	    usage();
	new_landscape = 0;
	break;
    case 's':				
	if (arg[2] != 0)
	    usage();
	no_border = 0;
	break;
    case 'w':				
	if (arg[2] != 0)
	    usage();
	new_wide_pages = 1;
	break;
    default:
	usage();
    }
}












int
mygetc(statusp)
int *statusp;
{
    static int curr = 0;
    static int size = 0;
    static unsigned char buffer[512];
    int c;

    *statusp = 0;

    
    if (curr >= size) {
	if (gets(buffer) == 0)
	    return  (-1);
	size = strlen(buffer);
	buffer[size] = '\n';
	buffer[++size] = '\0';
	curr = 0;
    }
    if (buffer[curr+1] != '\b')		
	return  buffer[curr++];

    
    if ((c = buffer[curr++]) == buffer[curr+1] &&
	buffer[curr]	== buffer[curr+2] &&
	c		== buffer[curr+3] &&
	buffer[curr]	== buffer[curr+4] &&
	c		== buffer[curr+5])
    {
	*statusp = 1;
	curr += 6;
    }

    
    return  c;
}




int
is_binaryfile(name)
char *name;
{
    if (chars > 120 || pages > 1) {
	first_page = 0;
	if (!print_binaries && (nonprinting_chars*100 / chars) >= 60)
	{
	    fprintf((&_iob[2]), "%s is a binary file: printing aborted\n", name);
	    return 1;
	}
    }
    return 0;
}




int
cut_filename(old_name, new_name)
char *old_name, *new_name;
{
    register char *p;
    register int i;
    
    p = old_name + (strlen(old_name)-1);
    while (p >= old_name && *p != '/') p--;
    
    for (i = 0, p++; *p != 0 && i < 20; i++)
	*new_name++ = *p++;
    *new_name = 0;
}




int
printchar(c)
unsigned char c;
{
    if (c >= ' ' && c < 0177)
    {
	if (c == '(' || c == ')' || c == '\\')
	    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('\\'))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('\\'))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('\\')), (&_iob[1]))));
	(--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((c))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((c))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((c)), (&_iob[1]))));
	return 0;
    }
    
    if (only_printable)
    {
	(--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((' '))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((' '))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((' ')), (&_iob[1]))));
	return 1;
    }
    
    if (c > 0177)
    {
	printf("M-");
	c &= 0177;
    }
    if (c < ' ')
    {
	(--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('^'))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('^'))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('^')), (&_iob[1]))));
	if ((c = c + '@') == '(' || c == ')' || c == '\\')
	    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('\\'))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('\\'))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('\\')), (&_iob[1]))));
	(--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((c))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((c))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((c)), (&_iob[1]))));
    }
    else if (c == 0177)
	printf("^?");
    else
	(--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((c))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((c))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((c)), (&_iob[1]))));
    
    return 1;
}




void
skip_page()
{
    if (twinpage == 0 || sheetside == 1)
	printf("%%%%Page: %d %d\n", sheets+1, sheets+1);
    startpage();
}




int
fold_line(name)
char *name;
{
    column = 0;
    printf(") s\n");
    if (++line >= linesperpage)
    {
	endpage();
	skip_page();
	if (first_page && is_binaryfile(name))
	    return 0;
	line = 0;
    }
    if (numbering)
	printf("(     +");
    else
	printf("( ");
    
    return 1;
}




char
cut_line()
{
    int c;
    int status;

    while ((c = mygetc(&status)) != (-1) && c != '\n' && c != '\f');
    return c;
}









void
printpage()
{
    sheetside = 0;
    sheets++;
    if (no_border == 0 && (twinpage || no_header))
	printf("%d sheetnumber\n", sheets - (restart ? old_sheets : 0));
    if (printdate)
	printf("currentdate\n");
    printf("showpage\n");
}





void
startpage()
{
    if (sheetside == 0 && landscape){
	printf("sheetwidth 0 inch translate	%% new origin\n");
	printf("90 rotate			%% landscape format\n");
    }
    pages++;
    if (no_header == 0)
	printf("%d %d header\n", pages - old_pages, sheetside);
    if (no_border == 0) {
	printf("%d border\n", sheetside);
	if (no_header == 0)
	    printf("hborder\n");
    }
    printf("/x0 upperx %d get bodymargin add def\n", sheetside);
    printf("/y0 uppery bodymargin bodyfontsize add %s add sub def\n",
	   no_header ? "0" : "headersize");
    printf("x0 y0 moveto\n");
    printf("bodyfont setfont\n");
}




void
cleanup()
{
    if (twinpage && sheetside == 1)
	printpage();
}





void
endpage()
{
    if (twinpage && sheetside == 0)
	sheetside = 1;
    else
	printpage();
}









void
print_file_prologue(name, title)
char *name, *title;
{
    int new_format, new_font;
    char *p, *string;
    int lines;
    float char_width, header_size;
    struct stat statbuf;
    char new_title[20+1];

    
    if (!twinfiles)
	cleanup();

    
    new_format = 0;
    if (new_landscape != landscape || new_wide_pages != wide_pages) {
	landscape = new_landscape;
	wide_pages = new_wide_pages;
	twinpage = landscape && !wide_pages;
	new_format = 1;
	printf("/landscape %s def\n", landscape ? "true" : "false");
	printf("/twinpage %s def\n", twinpage ? "true" : "false");
	printf("%% Character size for fonts.\n");
	if (landscape)
	    printf("/filenmfontsize 11 def\n");
	else
	    printf("/filenmfontsize 15 def\n");
	printf("/datefontsize filenmfontsize 0.8 mul def\n");
	printf("/datefont /Helvetica datefontsize getfont def\n");
	printf("/datewidth datefont setfont currdate stringwidth pop def\n");
	printf("/stdfilenmfont filenmfontname filenmfontsize getfont def\n");
	printf("/headermargin filenmfontsize 0.25 mul def\n");
    }

    
    if (no_header && name == title) {
	header_size = 0.0;
	printf("/headersize 0.0 def\n");
    }
    else {
	header_size = (landscape ? 0.22 : 0.29)*72;
	if (strlen(title) > 20) {
	    cut_filename(title, new_title);
	    title = new_title;
	}
	printf("/headersize %g inch def\n",
	       landscape ? 0.22 : 0.29);
    }

    
    new_font = 0;
    if (fontsize != new_fontsize || new_format ||
	lines_requested != new_linesrequest)
    {
	if (new_fontsize == 0.0 || (fontsize == new_fontsize && new_format))
	    new_fontsize = landscape ? 6.8 : 9.0;
	if (lines_requested != new_linesrequest) {
	    if ((lines_requested = new_linesrequest) != 0) {
		
		if (landscape)
		    lines = ((page_width - header_size) / new_fontsize) - 1;
		else
		    lines = ((page_height - header_size) / new_fontsize) - 1;
		if (lines_requested > lines || lines_requested <= 3*lines/4)
		    new_fontsize *= (float)lines / (float)lines_requested;
	    }
	}
	fontsize = new_fontsize;
	new_font = 1;
	printf("/bodyfontsize %g def\n", fontsize);
	printf("/bodyfont /CourierBack bodyfontsize getfont def\n");
	printf("/boldfont /Courier-Bold bodyfontsize getfont def\n");
	printf("/bodymargin bodyfontsize 0.7 mul def\n");
    }

    
    if (new_format || new_font) {
	char_width = 0.6 * fontsize;
	if (landscape) {
	    linesperpage = ((page_width - header_size) / fontsize) - 1;
	    if (wide_pages)
		columnsperline = (page_height / char_width) - 1;
	    else
		columnsperline = ((page_height / 2) / char_width) - 1;
	}
	else {
	    linesperpage = ((page_height - header_size) / fontsize) - 1;
	    columnsperline = (page_width / char_width) - 1;
	}
	if (lines_requested > 0)
	    linesperpage = lines_requested;
	if (linesperpage <= 0 || columnsperline <= 0) {
	    fprintf((&_iob[2]), "Font %g too big !!\n", fontsize);
	    exit(1);
	}
	printf("/lines %d def\n", linesperpage);
	printf("/columns %d def\n", columnsperline);
	printf("\n%% Logical page attributs (a half of a sheet).\n");
	printf("/pagewidth\n");
	printf("   bodyfont setfont (0) stringwidth pop columns mul bodymargin dup add add\n");
	printf("   def\n");
	printf("/pageheight\n");
	printf("   bodyfontsize lines mul bodymargin dup add add headersize add\n");
	printf("   def\n");
	printf("/filenmroom\n");
	printf("      pagewidth\n");
	printf("      filenmfontsize 4 mul datewidth add (Page 999) stringwidth pop add\n");
	printf("    sub\n");
	printf("  def\n");
	printf("\n%% Coordinates for upper corner of a logical page and for\n");
	printf("%% sheet number. Coordinates depend on format mode used.\n");
	printf("%% In twinpage mode, coordinate x of upper corner is not\n");
	printf("%% the same for left and right pages: upperx is an array of\n");
	printf("%% two elements, indexed by the side of the sheet.\n");
	printf("/topmargin margin twinpage {3} {2} ifelse div def\n");
	if (landscape) {
	    printf("%% Landscape format\n");
	    printf("/uppery rightmargin pageheight add bodymargin add def\n");
	    printf("/sheetnumbery datefontsize datefontsize add def\n");
	    printf("/datey sheetnumbery def\n");
	    if (twinpage) {
		printf("\n%% Two logical pages\n");
		printf("/upperx [ topmargin			%% left page\n");
		printf("          dup 2 mul pagewidth add	%% right page\n");
		printf("        ] def\n");
		printf("/sheetnumberx sheetheight topmargin sub def\n");
		printf("/datex topmargin def\n");
	    }
	    else {
		printf("\n%% Only one logical page\n");
		printf("/upperx [ topmargin dup ] def\n");
		printf("/sheetnumberx sheetheight topmargin sub datefontsize sub def\n");
		printf("/datex topmargin datefontsize add def\n");
	    }
	}
	else {
	    printf("\n%% Portrait format\n");
	    printf("/uppery topmargin pageheight add def\n");
	    printf("/upperx [ leftmargin dup ] def\n");
	    printf("/sheetnumberx sheetwidth rightmargin sub datefontsize sub def\n");
	    printf("/sheetnumbery\n");
	    printf("  sheetheight\n");
	    printf("  topmargin pageheight add datefontsize add headermargin add\n");
	    printf("    sub\n");
	    printf("  def\n");
	    printf("/datey sheetnumbery def\n");
	    printf("/datex leftmargin def\n");
	}
    }

    
    if (strcmp(name, "stdin") != 0) {
	if (fstat((((&_iob[0]))->_file), &statbuf) == -1) {
	    fprintf((&_iob[2]), "Error getting file modification time\n");
	    exit(1);
	}
	string = ctime(&statbuf.st_mtime);
	printf("/date (%.6s %.4s %.8s) def\n", string+4, string+20, string+11);
    }
    else
	printf("/currdate () def\n");	

    
    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('('))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('('))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('(')), (&_iob[1]))));
    for (p = title; *p != 0;)
	printchar(*p++);
    printf(") newfile\n");
}




void
print_file(name, header_opt, header)
char *name, *header;
int header_opt;
{
    register int c;
    int nchars;
    int start_line, start_page;
    int continue_exit;
    int status, new_status;

    
    print_file_prologue(name, header == 0 ? name : header);
    
    



    start_page = 0;
    
    






    nonprinting_chars = chars = 0;
    
    
    column = 0;
    line = line_number = 0;
    first_page = 1;
    start_line = 1;
    prefix_width = numbering ? 6 : 1;

    
    skip_page();

    
    status = 0;
    c = mygetc(&new_status);
    while (c != (-1)) {
	











	
	if (c == '\f' && interpret) {
	    
	    if (!start_line) {
		printf(") s\n");
		start_line = 1;
	    }
	    
	    if (start_page)
		skip_page();
	    
	    endpage();
	    start_page = 1;
	    
	    if (first_page && is_binaryfile(name))
		return;
	    line = 0;
	    if ((c = mygetc(&new_status)) == (-1))
		break;
	}
	
	
	if (start_line)	{
	    if (start_page) {
		
		skip_page();
		start_page = 0 ;
	    }
	    if (numbering)
		printf("(%-5d|", ++line_number);
	    else
		printf("( ");
	    start_line = 0;
	}
	
	
	
	
	if (status != new_status) {
	    printf(")\n");
	    printf("%s", status == 0 ? "b" : "st");
	    printf(" (");
	    status = new_status;
	}

	
	switch (c) {
	case '\b':
	    if (!interpret)
		goto print;
	    
	    
	    
	    if (column)
		column--;
	    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('\\'))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('\\'))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('\\')), (&_iob[1]))));
	    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)(('b'))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)(('b'))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)(('b')), (&_iob[1]))));
	    break;
	case '\n':
	    column = 0;
	    start_line = 1;
	    printf(") s\n");
	    if (++line >= linesperpage) {
		endpage();
		start_page = 1 ;
		if (first_page && is_binaryfile(name))
		    return;
		line = 0;
	    }
	    break;
	case '\t':
	    if (interpret) {
		continue_exit = 0;
		do {
		    if (++column + prefix_width > columnsperline) {
			if (folding) {
			    if (fold_line(name) == 0)
				return;
			}
			else {
			    c = cut_line();
			    continue_exit = 1;
			    break;
			}
		    }
		    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((' '))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((' '))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((' ')), (&_iob[1]))));
		} while (column % column_width);
		if (continue_exit)
		    continue;
		break;
	    }
	default:
	print:
	    if (only_printable)
		nchars = 1;
	    else {
		nchars = c > 0177 ? 2 : 0;
		nchars += (c&0177) < ' ' || (c&0177) == 0177 ? 2 : 1;
	    }
	    if (prefix_width + (column += nchars) > columnsperline)
		if (folding) {
		    if (fold_line(name) == 0)
			return;
		}
		else {
		    c = cut_line();
		    new_status = 0;
		    continue;
		}
	    nonprinting_chars += printchar(c);
	    chars++;
	    break;
	}
	c = mygetc(&new_status);
    }
    
    if (!start_line)
	printf(") s\n");
    if (!start_page)
	endpage();
}









void
print_prologue()
{
    register int c;
    struct _iobuf *f;
    char *string;


    struct timeval date;
    struct tm *p;


    
    if (prologue == 0)
	print_standard_prologue();
    else if ((f = fopen(prologue, "r")) != 0) {
	
	while ((c = (--(f)->_cnt>=0? ((int)*(f)->_ptr++):_filbuf(f))) != (-1))
	    (--((&_iob[1]))->_cnt >= 0 ? (int)(*((&_iob[1]))->_ptr++ = (unsigned char)((c))) : ((((&_iob[1]))->_flag & 0200) && -((&_iob[1]))->_cnt < ((&_iob[1]))->_bufsiz ? ((*((&_iob[1]))->_ptr = (unsigned char)((c))) != '\n' ? (int)(*((&_iob[1]))->_ptr++) : _flsbuf(*(unsigned char *)((&_iob[1]))->_ptr, (&_iob[1]))) : _flsbuf((unsigned char)((c)), (&_iob[1]))));
    }
    else {
	fprintf((&_iob[2]), "Postscript header missing: %s\n", prologue);
	exit(1);
    }

    
    printf("\n%% Initialize page description variables.\n");
    printf("/x0 0 def\n");
    printf("/y0 0 def\n");
    printf("/sheetheight %g inch def\n", 11.64);
    printf("/sheetwidth %g inch def\n", 8.27);
    printf("/margin %g inch def\n", 1.2);
    printf("/rightmargin margin 3 div def\n");
    printf("/leftmargin margin 2 mul 3 div def\n");
    printf("/twinfiles %s def\n", twinfiles ? "true" : "false");
    printf("/date () def\n");

    


    (void) gettimeofday(&date, (struct timezone *)0);
    p = localtime(&date.tv_sec);
    string = asctime(p);



    
    printf("/currdate (%.6s %.4s %.8s) def\n", string+4, string+20, string+11);

    
    printf("%%%%EndProlog\n\n");
    
    
    printf("/docsave save def\n");
}




void
print_standard_prologue()
{
    printf("%%!  PostScript Source Code\n");
    printf("%%\n");
    printf("%%%% Description: PostScript prolog for a2ps program.\n");
    printf("%%%% Copyright (c) 1990, Miguel Santana, miguel@imag.imag.fr\n");
    printf("%%%% a2ps 4.0\n");
    printf("%%%%EndComments\n");
    printf("\n/$a2psdict 100 dict def\n");
    printf("$a2psdict begin\n");
    printf("\n%% General macros.\n");
    printf("/xdef {exch def} bind def\n");
    printf("/getfont {exch findfont exch scalefont} bind def\n");
    printf("\n%% Create Courier backspace font\n");
    printf("/backspacefont {\n");
    printf("    /Courier findfont dup length dict begin\n");
    printf("	{ %%forall\n");
    printf("	    1 index /FID eq { pop pop } { def } ifelse\n");
    printf("	} forall\n");
    printf("	currentdict /UniqueID known { %%if\n");
    printf("	    /UniqueID UniqueID 16#800000 xor def\n");
    printf("	} if\n");
    printf("	CharStrings length 1 add dict begin\n");
    printf("	    CharStrings { def } forall\n");
    printf("	    /backspace { -600 0 0 0 0 0 setcachedevice } bind def\n");
    printf("	    currentdict\n");
    printf("	end\n");
    printf("	/CharStrings exch def\n");
    printf("	/Encoding Encoding 256 array copy def\n");
    printf("	Encoding 8 /backspace put\n");
    printf("	currentdict\n");
    printf("    end\n");
    printf("    definefont pop\n");
    printf("} bind def\n");
    printf("\n%% FUNCTIONS\n");
    printf("\n%% Function newfile: Initialize file printing.\n");
    printf("/newfile\n");
    printf("{ /filenm xdef\n");
    printf("  /filenmwidth filenm stringwidth pop def\n");
    printf("  /filenmfont\n");
    printf("       filenmwidth filenmroom gt\n");
    printf("       {\n");
    printf("	       filenmfontname\n");
    printf("	       filenmfontsize filenmroom mul filenmwidth div\n");
    printf("	     getfont\n");
    printf("       }\n");
    printf("       { stdfilenmfont }\n");
    printf("     ifelse\n");
    printf("  def\n");
    printf("} bind def\n");
    printf("\n%% Function header: prints page header. no page and\n");
    printf("%% sheetside are passed as arguments.\n");
    printf("/header\n");
    printf("  { upperx 1 index get  uppery headersize sub 1 add  moveto\n");
    printf("    datefont setfont\n");
    printf("    gsave\n");
    printf("      upperx 1 index get uppery moveto pop\n");
    printf("      0 headersize 2 div neg rmoveto \n");
    printf("      headersize setlinewidth\n");
    printf("      0.85 setgray\n");
    printf("      pagewidth 0 rlineto stroke\n");
    printf("    grestore\n");
    printf("    gsave\n");
    printf("      datefontsize headermargin rmoveto\n");
    printf("      date show				%% date/hour\n");
    printf("    grestore\n");
    printf("    gsave\n");
    printf("      pnum cvs pop				%% page pop up\n");
    printf("        pagewidth (Page 999) stringwidth pop sub\n");
    printf("        headermargin\n");
    printf("	  rmoveto\n");
    printf("      (Page ) show pnum show		%% page number\n");
    printf("    grestore\n");
    printf("    empty pnum copy pop\n");
    printf("    gsave\n");
    printf("      filenmfont setfont\n");
    printf("         filenmroom filenm stringwidth pop sub 2 div datewidth add\n");
    printf("          bodymargin 2 mul \n");
    printf("        add \n");
    printf("        headermargin\n");
    printf("      rmoveto\n");
    printf("        filenm show			%% file name\n");
    printf("      grestore\n");
    printf("    } bind def\n");
    printf("\n%% Function border: prints border page. Use sheetside as arg\n");
    printf("/border \n");
    printf("{ upperx 1 index get uppery moveto pop\n");
    printf("  gsave				%% print four sides\n");
    printf("    0.7 setlinewidth		%% of the square\n");
    printf("    pagewidth 0 rlineto\n");
    printf("    0 pageheight neg rlineto\n");
    printf("    pagewidth neg 0 rlineto\n");
    printf("    closepath stroke\n");
    printf("  grestore\n");
    printf("} bind def\n");
    printf("\n%% Function hborder: completes border of the header.\n");
    printf("/hborder \n");
    printf("{ gsave\n");
    printf("	0.7 setlinewidth\n");
    printf("	0 headersize neg rmoveto\n");
    printf("	pagewidth 0 rlineto\n");
    printf("	stroke\n");
    printf("  grestore\n");
    printf("} bind def\n");
    printf("\n%% Function sheetnumber: prints the sheet number.\n");
    printf("/sheetnumber\n");
    printf("    { sheetnumberx sheetnumbery moveto\n");
    printf("      datefont setfont\n");
    printf("      pnum cvs\n");
    printf("	  dup stringwidth pop (0) stringwidth pop sub neg 0 rmoveto show\n");
    printf("      empty pnum copy pop\n");
    printf("    } bind def\n");
    printf("\n%% Function currentdate: prints the current date.\n");
    printf("/currentdate\n");
    printf("    { datex datey moveto\n");
    printf("      bodyfont setfont\n");
    printf("      (Date: ) show\n");
    printf("      currdate show\n");
    printf("    } bind def\n");
    printf("\n%% Function s: print a source line\n");
    printf("/s  { show\n");
    printf("      /y0 y0 bodyfontsize sub def\n");
    printf("      x0 y0 moveto\n");
    printf("    } bind def\n");
    printf("\n%% Functions b and st: change to bold or standard font\n");
    printf("/b  { show\n");
    printf("      boldfont setfont\n");
    printf("    } bind def\n");
    printf("/st { show\n");
    printf("      bodyfont setfont\n");
    printf("    } bind def\n");
    printf("\n%% Strings used to make easy printing numbers\n");
    printf("/pnum 12 string def\n");
    printf("/empty 12 string def\n");
    printf("\n%% Global initializations\n");
    printf("\n/CourierBack backspacefont\n");
    printf("/filenmfontname /Helvetica-Bold def\n");
    printf("/inch {72 mul} bind def\n");
}





void
main(argc, argv)
int argc;
char *argv[];
{
    register int narg;
    register char *arg;
    int number;

    int fd[2], lpr_pid;

    
    
    command = argv[0];
    arg = argv[narg = 1];
    while (narg < argc) {
	if (arg[0] == '-')
	    set_global_option(arg);
	arg = argv[++narg];
    }


    
    if (lpr_print) {
	pipe(fd);
	if ((lpr_pid = fork()) == 0) {
	    dup2(fd[0], 0);
	    close(fd[0]); close(fd[1]);

	    execlp("lpr", "lpr", "-l", lpr_opt, (char *)0);

	    fprintf((&_iob[2]), "Error starting lpr process \n");
	    exit(1);
	}
	dup2(fd[1],1);
	close(fd[0]);
	close(fd[1]);
    }


    
    landscape = wide_pages = -1;	
    fontsize = -1.0;			
    page_height = (11.64 - 1.2) * 72;
    page_width = (8.27 - 1.2) * 72;
    
    
    print_prologue();
    
    
    arg = argv[narg = 1];
    while (narg < argc) {
	if (arg[0] != 0) {
	    if (arg[0] == '-')
		set_positional_option(arg);
	    else {
		if (freopen(arg, "r", (&_iob[0])) == 0) {
		    fprintf((&_iob[2]), "Error opening %s\n", arg);
		    cleanup();
		    printf("\n%%%%Trailer\ndocsave restore end\n\4");
		    exit(1);
		}
		no_files = 0;

		
		old_pages = pages;
		if (twinfiles && twinpage)
		    old_sheets = sheets;
		else
		    old_sheets = sheets + sheetside;

		
		print_file(arg, no_header, header_text);

		
		number = pages - old_pages;
		fprintf((&_iob[2]), "[%s: %d page%s on ", arg,
			number, number == 1 ? "" : "s");
		number = sheets - old_sheets + sheetside;
		fprintf((&_iob[2]), "%d sheet%s]\n", number, number == 1 ? "" : "s");

		
		header_text = 0;
	    }
	}
	arg = argv[++narg];
    }
    if (no_files)
	print_file("stdin", no_header, header_text);

    
    if (pages != old_pages) {
	fprintf((&_iob[2]), "[Total: %d page%s on ", pages, pages == 1 ? "" : "s");
	number = sheets + sheetside;
	fprintf((&_iob[2]), "%d sheet%s]\n", number, number == 1 ? "" : "s");
    }

    
    cleanup();
    printf("\n%%%%Trailer\ndocsave restore end\n");
    exit(0);
}
